// quadric.c
//  GLU2̥֥ȤǤ磻䡼ɽ, ž
//  žϥޥκ,, ܥѹ
//
//- Feb 2 2003 -----------------------------------

#include <GL/glut.h>

GLUquadricObj *Sphere;  // 2̥֥ȤؤΥݥ
static float theta[] = {0.0, 0.0, 0.0};
static int axis = 1;

void init(void)
{
  glClearColor ( 0.0, 0.0, 0.0, 0.0 );
  Sphere = gluNewQuadric();
  gluQuadricDrawStyle( Sphere, GLU_LINE );
}

void display(void)
{
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  glLoadIdentity();
  glRotatef( theta[0], 1.0, 0.0, 0.0 );
  glRotatef( theta[1], 0.0, 1.0, 0.0 );
  glRotatef( theta[2], 0.0, 0.0, 1.0 );
  
  gluSphere( Sphere, 1.0, 15, 15 );  // 磻䡼

  glutSwapBuffers();
}

//------------------------------------------------
// Idle callback, spin cube 1 degrees about selected axis
//------------------------------------------------
void spin()
{
	theta[axis] += 1.0;
	if( theta[axis] > 360.0 ) theta[axis] -= 360.0;
	display();
}

//------------------------------------------------
// mouse callback, selects an axis about which to rotate
//------------------------------------------------
void mouse(int btn, int state, int x, int y)
{ // ž
  if(btn==GLUT_LEFT_BUTTON   && state == GLUT_DOWN) axis = 0;
  if(btn==GLUT_MIDDLE_BUTTON && state == GLUT_DOWN) axis = 1;
  if(btn==GLUT_RIGHT_BUTTON  && state == GLUT_DOWN) axis = 2;
}

void reshape (int w, int h)
{
  glViewport ( 0, 0, w, h );
  glMatrixMode ( GL_PROJECTION );
  glLoadIdentity ();
  if ( w <= h )
    glOrtho( -2.0, 2.0, -2.0 * h/w, 2.0 * h/w, -10.0, 10.0 );
  else
    glOrtho( -2.0 * w/h, 2.0 * w/h, -2.0, 2.0, -10.0, 10.0 );
  glMatrixMode( GL_MODELVIEW );
}

int main( int argc, char** argv )
{
  glutInit( &argc, argv );
  glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB );
  glutInitWindowSize ( 400, 400 );
  glutCreateWindow ( "Sphere" );
  init();

  glutReshapeFunc( reshape );
  glutDisplayFunc( display );
  glutIdleFunc( spin );
  glutMouseFunc( mouse );

  glutMainLoop();
  return 0;
}
